From 3455b1b857bebff08e2986b2bdeadda1ed825277 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Wed, 11 Aug 2021 17:30:44 +0000
Subject: [PATCH] [arm64] use ALL_LUMA_PU

---
 source/common/aarch64/asm-primitives.cpp | 387 +----------------------
 1 file changed, 15 insertions(+), 372 deletions(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index f5c104e..cdaf19b 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -42,6 +42,7 @@ extern "C" {
 #include "intrapred-prim.h"
 
 #define ALL_LUMA_PU_TYPED(prim, fncdef, fname, cpu) \
+    p.pu[LUMA_4x4].prim   = fncdef PFX(fname ## _4x4_ ## cpu); \
     p.pu[LUMA_8x8].prim   = fncdef PFX(fname ## _8x8_ ## cpu); \
     p.pu[LUMA_16x16].prim = fncdef PFX(fname ## _16x16_ ## cpu); \
     p.pu[LUMA_32x32].prim = fncdef PFX(fname ## _32x32_ ## cpu); \
@@ -184,58 +185,20 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         // ssim_4x4x2_core
         p.ssim_4x4x2_core = PFX(ssim_4x4x2_core_neon);
 
-        // addAvg
-         p.pu[LUMA_4x4].addAvg[NONALIGNED]   = PFX(addAvg_4x4_neon);
-         p.pu[LUMA_4x8].addAvg[NONALIGNED]   = PFX(addAvg_4x8_neon);
-         p.pu[LUMA_4x16].addAvg[NONALIGNED]  = PFX(addAvg_4x16_neon);
-         p.pu[LUMA_8x4].addAvg[NONALIGNED]   = PFX(addAvg_8x4_neon);
-         p.pu[LUMA_8x8].addAvg[NONALIGNED]   = PFX(addAvg_8x8_neon);
-         p.pu[LUMA_8x16].addAvg[NONALIGNED]  = PFX(addAvg_8x16_neon);
-         p.pu[LUMA_8x32].addAvg[NONALIGNED]  = PFX(addAvg_8x32_neon);
-         p.pu[LUMA_12x16].addAvg[NONALIGNED] = PFX(addAvg_12x16_neon);
-         p.pu[LUMA_16x4].addAvg[NONALIGNED]  = PFX(addAvg_16x4_neon);
-         p.pu[LUMA_16x8].addAvg[NONALIGNED]  = PFX(addAvg_16x8_neon);
-         p.pu[LUMA_16x12].addAvg[NONALIGNED] = PFX(addAvg_16x12_neon);
-         p.pu[LUMA_16x16].addAvg[NONALIGNED] = PFX(addAvg_16x16_neon);
-         p.pu[LUMA_16x32].addAvg[NONALIGNED] = PFX(addAvg_16x32_neon);
-         p.pu[LUMA_16x64].addAvg[NONALIGNED] = PFX(addAvg_16x64_neon);
-         p.pu[LUMA_24x32].addAvg[NONALIGNED] = PFX(addAvg_24x32_neon);
-         p.pu[LUMA_32x8].addAvg[NONALIGNED]  = PFX(addAvg_32x8_neon);
-         p.pu[LUMA_32x16].addAvg[NONALIGNED] = PFX(addAvg_32x16_neon);
-         p.pu[LUMA_32x24].addAvg[NONALIGNED] = PFX(addAvg_32x24_neon);
-         p.pu[LUMA_32x32].addAvg[NONALIGNED] = PFX(addAvg_32x32_neon);
-         p.pu[LUMA_32x64].addAvg[NONALIGNED] = PFX(addAvg_32x64_neon);
-         p.pu[LUMA_48x64].addAvg[NONALIGNED] = PFX(addAvg_48x64_neon);
-         p.pu[LUMA_64x16].addAvg[NONALIGNED] = PFX(addAvg_64x16_neon);
-         p.pu[LUMA_64x32].addAvg[NONALIGNED] = PFX(addAvg_64x32_neon);
-         p.pu[LUMA_64x48].addAvg[NONALIGNED] = PFX(addAvg_64x48_neon);
-         p.pu[LUMA_64x64].addAvg[NONALIGNED] = PFX(addAvg_64x64_neon);
-
-         p.pu[LUMA_4x4].addAvg[ALIGNED]   = PFX(addAvg_4x4_neon);
-         p.pu[LUMA_4x8].addAvg[ALIGNED]   = PFX(addAvg_4x8_neon);
-         p.pu[LUMA_4x16].addAvg[ALIGNED]  = PFX(addAvg_4x16_neon);
-         p.pu[LUMA_8x4].addAvg[ALIGNED]   = PFX(addAvg_8x4_neon);
-         p.pu[LUMA_8x8].addAvg[ALIGNED]   = PFX(addAvg_8x8_neon);
-         p.pu[LUMA_8x16].addAvg[ALIGNED]  = PFX(addAvg_8x16_neon);
-         p.pu[LUMA_8x32].addAvg[ALIGNED]  = PFX(addAvg_8x32_neon);
-         p.pu[LUMA_12x16].addAvg[ALIGNED] = PFX(addAvg_12x16_neon);
-         p.pu[LUMA_16x4].addAvg[ALIGNED]  = PFX(addAvg_16x4_neon);
-         p.pu[LUMA_16x8].addAvg[ALIGNED]  = PFX(addAvg_16x8_neon);
-         p.pu[LUMA_16x12].addAvg[ALIGNED] = PFX(addAvg_16x12_neon);
-         p.pu[LUMA_16x16].addAvg[ALIGNED] = PFX(addAvg_16x16_neon);
-         p.pu[LUMA_16x32].addAvg[ALIGNED] = PFX(addAvg_16x32_neon);
-         p.pu[LUMA_16x64].addAvg[ALIGNED] = PFX(addAvg_16x64_neon);
-         p.pu[LUMA_24x32].addAvg[ALIGNED] = PFX(addAvg_24x32_neon);
-         p.pu[LUMA_32x8].addAvg[ALIGNED]  = PFX(addAvg_32x8_neon);
-         p.pu[LUMA_32x16].addAvg[ALIGNED] = PFX(addAvg_32x16_neon);
-         p.pu[LUMA_32x24].addAvg[ALIGNED] = PFX(addAvg_32x24_neon);
-         p.pu[LUMA_32x32].addAvg[ALIGNED] = PFX(addAvg_32x32_neon);
-         p.pu[LUMA_32x64].addAvg[ALIGNED] = PFX(addAvg_32x64_neon);
-         p.pu[LUMA_48x64].addAvg[ALIGNED] = PFX(addAvg_48x64_neon);
-         p.pu[LUMA_64x16].addAvg[ALIGNED] = PFX(addAvg_64x16_neon);
-         p.pu[LUMA_64x32].addAvg[ALIGNED] = PFX(addAvg_64x32_neon);
-         p.pu[LUMA_64x48].addAvg[ALIGNED] = PFX(addAvg_64x48_neon);
-         p.pu[LUMA_64x64].addAvg[ALIGNED] = PFX(addAvg_64x64_neon);
+        ALL_LUMA_PU(addAvg[NONALIGNED], addAvg, neon);
+        ALL_LUMA_PU(addAvg[ALIGNED], addAvg, neon);
+        ALL_LUMA_PU(satd, pixel_satd, neon);
+        ALL_LUMA_PU(sad, pixel_sad, neon);
+        ALL_LUMA_PU(sad_x3, sad_x3, neon);
+        ALL_LUMA_PU(sad_x4, sad_x4, neon);
+        ALL_LUMA_PU(pixelavg_pp[NONALIGNED], pixel_avg_pp, neon);
+        ALL_LUMA_PU(pixelavg_pp[ALIGNED], pixel_avg_pp, neon);
+        ALL_LUMA_PU(luma_vpp, interp_8tap_vert_pp, neon);
+        ALL_LUMA_PU(luma_vsp, interp_8tap_vert_sp, neon);
+        ALL_LUMA_PU(luma_vps, interp_8tap_vert_ps, neon);
+        ALL_LUMA_PU(luma_hpp, interp_horiz_pp, neon);
+        ALL_LUMA_PU(luma_hps, interp_horiz_ps, neon);
+        ALL_LUMA_PU(copy_pp, blockcopy_pp, neon);
 
         // chroma addAvg
         p.chroma[X265_CSP_I420].pu[CHROMA_420_4x2].addAvg[NONALIGNED]   = PFX(addAvg_4x2_neon);
@@ -328,32 +291,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.chroma[X265_CSP_I422].pu[CHROMA_422_32x48].addAvg[ALIGNED] = PFX(addAvg_32x48_neon);
         p.chroma[X265_CSP_I422].pu[CHROMA_422_32x64].addAvg[ALIGNED] = PFX(addAvg_32x64_neon);
 
-        // luma satd
-         p.pu[LUMA_4x4].satd   = PFX(pixel_satd_4x4_neon);
-         p.pu[LUMA_4x8].satd   = PFX(pixel_satd_4x8_neon);
-         p.pu[LUMA_4x16].satd  = PFX(pixel_satd_4x16_neon);
-         p.pu[LUMA_8x4].satd   = PFX(pixel_satd_8x4_neon);
-         p.pu[LUMA_8x8].satd   = PFX(pixel_satd_8x8_neon);
-         p.pu[LUMA_8x16].satd  = PFX(pixel_satd_8x16_neon);
-         p.pu[LUMA_8x32].satd  = PFX(pixel_satd_8x32_neon);
-         p.pu[LUMA_12x16].satd = PFX(pixel_satd_12x16_neon);
-         p.pu[LUMA_16x4].satd  = PFX(pixel_satd_16x4_neon);
-         p.pu[LUMA_16x8].satd  = PFX(pixel_satd_16x8_neon);
-         p.pu[LUMA_16x16].satd = PFX(pixel_satd_16x16_neon);
-         p.pu[LUMA_16x32].satd = PFX(pixel_satd_16x32_neon);
-         p.pu[LUMA_16x64].satd = PFX(pixel_satd_16x64_neon);
-         p.pu[LUMA_24x32].satd = PFX(pixel_satd_24x32_neon);
-         p.pu[LUMA_32x8].satd  = PFX(pixel_satd_32x8_neon);
-         p.pu[LUMA_32x16].satd = PFX(pixel_satd_32x16_neon);
-         p.pu[LUMA_32x24].satd = PFX(pixel_satd_32x24_neon);
-         p.pu[LUMA_32x32].satd = PFX(pixel_satd_32x32_neon);
-         p.pu[LUMA_32x64].satd = PFX(pixel_satd_32x64_neon);
-         p.pu[LUMA_48x64].satd = PFX(pixel_satd_48x64_neon);
-         p.pu[LUMA_64x16].satd = PFX(pixel_satd_64x16_neon);
-         p.pu[LUMA_64x32].satd = PFX(pixel_satd_64x32_neon);
-         p.pu[LUMA_64x48].satd = PFX(pixel_satd_64x48_neon);
-         p.pu[LUMA_64x64].satd = PFX(pixel_satd_64x64_neon);
-
         // chroma satd
          p.chroma[X265_CSP_I420].pu[CHROMA_420_4x4].satd    = PFX(pixel_satd_4x4_neon);
          p.chroma[X265_CSP_I420].pu[CHROMA_420_4x8].satd    = PFX(pixel_satd_4x8_neon);
@@ -396,113 +333,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
          p.chroma[X265_CSP_I422].pu[CHROMA_422_32x48].satd  = PFX(pixel_satd_32x48_neon);
          p.chroma[X265_CSP_I422].pu[CHROMA_422_32x64].satd  = PFX(pixel_satd_32x64_neon);
 
-        // sad_x3
-        p.pu[LUMA_4x4].sad_x3   = PFX(sad_x3_4x4_neon);
-        p.pu[LUMA_4x8].sad_x3   = PFX(sad_x3_4x8_neon);
-        p.pu[LUMA_4x16].sad_x3  = PFX(sad_x3_4x16_neon);
-        p.pu[LUMA_8x4].sad_x3   = PFX(sad_x3_8x4_neon);
-        p.pu[LUMA_8x8].sad_x3   = PFX(sad_x3_8x8_neon);
-        p.pu[LUMA_8x16].sad_x3  = PFX(sad_x3_8x16_neon);
-        p.pu[LUMA_8x32].sad_x3  = PFX(sad_x3_8x32_neon);
-        p.pu[LUMA_12x16].sad_x3 = PFX(sad_x3_12x16_neon);
-        p.pu[LUMA_16x4].sad_x3  = PFX(sad_x3_16x4_neon);
-        p.pu[LUMA_16x8].sad_x3  = PFX(sad_x3_16x8_neon);
-        p.pu[LUMA_16x12].sad_x3 = PFX(sad_x3_16x12_neon);
-        p.pu[LUMA_16x16].sad_x3 = PFX(sad_x3_16x16_neon);
-        p.pu[LUMA_16x32].sad_x3 = PFX(sad_x3_16x32_neon);
-        p.pu[LUMA_16x64].sad_x3 = PFX(sad_x3_16x64_neon);
-        p.pu[LUMA_24x32].sad_x3 = PFX(sad_x3_24x32_neon);
-        p.pu[LUMA_32x8].sad_x3  = PFX(sad_x3_32x8_neon);
-        p.pu[LUMA_32x16].sad_x3 = PFX(sad_x3_32x16_neon);
-        p.pu[LUMA_32x24].sad_x3 = PFX(sad_x3_32x24_neon);
-        p.pu[LUMA_32x32].sad_x3 = PFX(sad_x3_32x32_neon);
-        p.pu[LUMA_32x64].sad_x3 = PFX(sad_x3_32x64_neon);
-        p.pu[LUMA_48x64].sad_x3 = PFX(sad_x3_48x64_neon);
-        p.pu[LUMA_64x16].sad_x3 = PFX(sad_x3_64x16_neon);
-        p.pu[LUMA_64x32].sad_x3 = PFX(sad_x3_64x32_neon);
-        p.pu[LUMA_64x48].sad_x3 = PFX(sad_x3_64x48_neon);
-        p.pu[LUMA_64x64].sad_x3 = PFX(sad_x3_64x64_neon);
-
-        // sad_x4
-        p.pu[LUMA_4x4].sad_x4   = PFX(sad_x4_4x4_neon);
-        p.pu[LUMA_4x8].sad_x4   = PFX(sad_x4_4x8_neon);
-        p.pu[LUMA_4x16].sad_x4  = PFX(sad_x4_4x16_neon);
-        p.pu[LUMA_8x4].sad_x4   = PFX(sad_x4_8x4_neon);
-        p.pu[LUMA_8x8].sad_x4   = PFX(sad_x4_8x8_neon);
-        p.pu[LUMA_8x16].sad_x4  = PFX(sad_x4_8x16_neon);
-        p.pu[LUMA_8x32].sad_x4  = PFX(sad_x4_8x32_neon);
-        p.pu[LUMA_12x16].sad_x4 = PFX(sad_x4_12x16_neon);
-        p.pu[LUMA_16x4].sad_x4  = PFX(sad_x4_16x4_neon);
-        p.pu[LUMA_16x8].sad_x4  = PFX(sad_x4_16x8_neon);
-        p.pu[LUMA_16x12].sad_x4 = PFX(sad_x4_16x12_neon);
-        p.pu[LUMA_16x16].sad_x4 = PFX(sad_x4_16x16_neon);
-        p.pu[LUMA_16x32].sad_x4 = PFX(sad_x4_16x32_neon);
-        p.pu[LUMA_16x64].sad_x4 = PFX(sad_x4_16x64_neon);
-        p.pu[LUMA_24x32].sad_x4 = PFX(sad_x4_24x32_neon);
-        p.pu[LUMA_32x8].sad_x4  = PFX(sad_x4_32x8_neon);
-        p.pu[LUMA_32x16].sad_x4 = PFX(sad_x4_32x16_neon);
-        p.pu[LUMA_32x24].sad_x4 = PFX(sad_x4_32x24_neon);
-        p.pu[LUMA_32x32].sad_x4 = PFX(sad_x4_32x32_neon);
-        p.pu[LUMA_32x64].sad_x4 = PFX(sad_x4_32x64_neon);
-        p.pu[LUMA_48x64].sad_x4 = PFX(sad_x4_48x64_neon);
-        p.pu[LUMA_64x16].sad_x4 = PFX(sad_x4_64x16_neon);
-        p.pu[LUMA_64x32].sad_x4 = PFX(sad_x4_64x32_neon);
-        p.pu[LUMA_64x48].sad_x4 = PFX(sad_x4_64x48_neon);
-        p.pu[LUMA_64x64].sad_x4 = PFX(sad_x4_64x64_neon);
-
-        // pixel_avg_pp
-        p.pu[LUMA_4x4].pixelavg_pp[NONALIGNED]   = PFX(pixel_avg_pp_4x4_neon);
-        p.pu[LUMA_4x8].pixelavg_pp[NONALIGNED]   = PFX(pixel_avg_pp_4x8_neon);
-        p.pu[LUMA_4x16].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_4x16_neon);
-        p.pu[LUMA_8x4].pixelavg_pp[NONALIGNED]   = PFX(pixel_avg_pp_8x4_neon);
-        p.pu[LUMA_8x8].pixelavg_pp[NONALIGNED]   = PFX(pixel_avg_pp_8x8_neon);
-        p.pu[LUMA_8x16].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_8x16_neon);
-        p.pu[LUMA_8x32].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_8x32_neon);
-        p.pu[LUMA_12x16].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_12x16_neon);
-        p.pu[LUMA_16x4].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_16x4_neon);
-        p.pu[LUMA_16x8].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_16x8_neon);
-        p.pu[LUMA_16x12].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_16x12_neon);
-        p.pu[LUMA_16x16].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_16x16_neon);
-        p.pu[LUMA_16x32].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_16x32_neon);
-        p.pu[LUMA_16x64].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_16x64_neon);
-        p.pu[LUMA_24x32].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_24x32_neon);
-        p.pu[LUMA_32x8].pixelavg_pp[NONALIGNED]  = PFX(pixel_avg_pp_32x8_neon);
-        p.pu[LUMA_32x16].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_32x16_neon);
-        p.pu[LUMA_32x24].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_32x24_neon);
-        p.pu[LUMA_32x32].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_32x32_neon);
-        p.pu[LUMA_32x64].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_32x64_neon);
-        p.pu[LUMA_48x64].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_48x64_neon);
-        p.pu[LUMA_64x16].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_64x16_neon);
-        p.pu[LUMA_64x32].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_64x32_neon);
-        p.pu[LUMA_64x48].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_64x48_neon);
-        p.pu[LUMA_64x64].pixelavg_pp[NONALIGNED] = PFX(pixel_avg_pp_64x64_neon);
-
-        p.pu[LUMA_4x4].pixelavg_pp[ALIGNED]   = PFX(pixel_avg_pp_4x4_neon);
-        p.pu[LUMA_4x8].pixelavg_pp[ALIGNED]   = PFX(pixel_avg_pp_4x8_neon);
-        p.pu[LUMA_4x16].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_4x16_neon);
-        p.pu[LUMA_8x4].pixelavg_pp[ALIGNED]   = PFX(pixel_avg_pp_8x4_neon);
-        p.pu[LUMA_8x8].pixelavg_pp[ALIGNED]   = PFX(pixel_avg_pp_8x8_neon);
-        p.pu[LUMA_8x16].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_8x16_neon);
-        p.pu[LUMA_8x32].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_8x32_neon);
-        p.pu[LUMA_12x16].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_12x16_neon);
-        p.pu[LUMA_16x4].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_16x4_neon);
-        p.pu[LUMA_16x8].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_16x8_neon);
-        p.pu[LUMA_16x12].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_16x12_neon);
-        p.pu[LUMA_16x16].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_16x16_neon);
-        p.pu[LUMA_16x32].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_16x32_neon);
-        p.pu[LUMA_16x64].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_16x64_neon);
-        p.pu[LUMA_24x32].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_24x32_neon);
-        p.pu[LUMA_32x8].pixelavg_pp[ALIGNED]  = PFX(pixel_avg_pp_32x8_neon);
-        p.pu[LUMA_32x16].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_32x16_neon);
-        p.pu[LUMA_32x24].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_32x24_neon);
-        p.pu[LUMA_32x32].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_32x32_neon);
-        p.pu[LUMA_32x64].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_32x64_neon);
-        p.pu[LUMA_48x64].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_48x64_neon);
-        p.pu[LUMA_64x16].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x16_neon);
-        p.pu[LUMA_64x32].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x32_neon);
-        p.pu[LUMA_64x48].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x48_neon);
-        p.pu[LUMA_64x64].pixelavg_pp[ALIGNED] = PFX(pixel_avg_pp_64x64_neon);
-
         // planecopy
         p.planecopy_cp = PFX(pixel_planecopy_cp_neon);
 
@@ -773,33 +603,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.cu[BLOCK_32x32].var = PFX(pixel_var_32x32_neon);
         p.cu[BLOCK_64x64].var = PFX(pixel_var_64x64_neon);
 
-        // blockcopy
-        p.pu[LUMA_16x16].copy_pp = PFX(blockcopy_pp_16x16_neon);
-        p.pu[LUMA_8x4].copy_pp   = PFX(blockcopy_pp_8x4_neon);
-        p.pu[LUMA_8x8].copy_pp   = PFX(blockcopy_pp_8x8_neon);
-        p.pu[LUMA_8x16].copy_pp  = PFX(blockcopy_pp_8x16_neon);
-        p.pu[LUMA_8x32].copy_pp  = PFX(blockcopy_pp_8x32_neon);
-        p.pu[LUMA_12x16].copy_pp = PFX(blockcopy_pp_12x16_neon);
-        p.pu[LUMA_4x4].copy_pp   = PFX(blockcopy_pp_4x4_neon);
-        p.pu[LUMA_4x8].copy_pp   = PFX(blockcopy_pp_4x8_neon);
-        p.pu[LUMA_4x16].copy_pp  = PFX(blockcopy_pp_4x16_neon);
-        p.pu[LUMA_16x4].copy_pp  = PFX(blockcopy_pp_16x4_neon);
-        p.pu[LUMA_16x8].copy_pp  = PFX(blockcopy_pp_16x8_neon);
-        p.pu[LUMA_16x12].copy_pp = PFX(blockcopy_pp_16x12_neon);
-        p.pu[LUMA_16x32].copy_pp = PFX(blockcopy_pp_16x32_neon);
-        p.pu[LUMA_16x64].copy_pp = PFX(blockcopy_pp_16x64_neon);
-        p.pu[LUMA_24x32].copy_pp = PFX(blockcopy_pp_24x32_neon);
-        p.pu[LUMA_32x8].copy_pp  = PFX(blockcopy_pp_32x8_neon);
-        p.pu[LUMA_32x16].copy_pp = PFX(blockcopy_pp_32x16_neon);
-        p.pu[LUMA_32x24].copy_pp = PFX(blockcopy_pp_32x24_neon);
-        p.pu[LUMA_32x32].copy_pp = PFX(blockcopy_pp_32x32_neon);
-        p.pu[LUMA_32x64].copy_pp = PFX(blockcopy_pp_32x64_neon);
-        p.pu[LUMA_48x64].copy_pp = PFX(blockcopy_pp_48x64_neon);
-        p.pu[LUMA_64x16].copy_pp = PFX(blockcopy_pp_64x16_neon);
-        p.pu[LUMA_64x32].copy_pp = PFX(blockcopy_pp_64x32_neon);
-        p.pu[LUMA_64x48].copy_pp = PFX(blockcopy_pp_64x48_neon);
-        p.pu[LUMA_64x64].copy_pp = PFX(blockcopy_pp_64x64_neon);
-
         // chroma blockcopy
         p.chroma[X265_CSP_I420].pu[CHROMA_420_2x4].copy_pp   = PFX(blockcopy_pp_2x4_neon);
         p.chroma[X265_CSP_I420].pu[CHROMA_420_2x8].copy_pp   = PFX(blockcopy_pp_2x8_neon);
@@ -850,112 +653,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.chroma[X265_CSP_I422].pu[CHROMA_422_32x48].copy_pp = PFX(blockcopy_pp_32x48_neon);
         p.chroma[X265_CSP_I422].pu[CHROMA_422_32x64].copy_pp = PFX(blockcopy_pp_32x64_neon);
 
-        // sad
-        p.pu[LUMA_4x4].sad    = PFX(pixel_sad_4x4_neon);
-        p.pu[LUMA_4x8].sad    = PFX(pixel_sad_4x8_neon);
-        p.pu[LUMA_4x16].sad   = PFX(pixel_sad_4x16_neon);
-        p.pu[LUMA_8x4].sad    = PFX(pixel_sad_8x4_neon);
-        p.pu[LUMA_8x8].sad    = PFX(pixel_sad_8x8_neon);
-        p.pu[LUMA_8x16].sad   = PFX(pixel_sad_8x16_neon);
-        p.pu[LUMA_8x32].sad   = PFX(pixel_sad_8x32_neon);
-        p.pu[LUMA_16x4].sad   = PFX(pixel_sad_16x4_neon);
-        p.pu[LUMA_16x8].sad   = PFX(pixel_sad_16x8_neon);
-        p.pu[LUMA_16x16].sad  = PFX(pixel_sad_16x16_neon);
-        p.pu[LUMA_16x12].sad  = PFX(pixel_sad_16x12_neon);
-        p.pu[LUMA_16x32].sad  = PFX(pixel_sad_16x32_neon);
-        p.pu[LUMA_16x64].sad  = PFX(pixel_sad_16x64_neon);
-        p.pu[LUMA_32x8].sad   = PFX(pixel_sad_32x8_neon);
-        p.pu[LUMA_32x16].sad  = PFX(pixel_sad_32x16_neon);
-        p.pu[LUMA_32x32].sad  = PFX(pixel_sad_32x32_neon);
-        p.pu[LUMA_32x64].sad  = PFX(pixel_sad_32x64_neon);
-        p.pu[LUMA_32x24].sad  = PFX(pixel_sad_32x24_neon);
-        p.pu[LUMA_64x16].sad  = PFX(pixel_sad_64x16_neon);
-        p.pu[LUMA_64x32].sad  = PFX(pixel_sad_64x32_neon);
-        p.pu[LUMA_64x64].sad  = PFX(pixel_sad_64x64_neon);
-        p.pu[LUMA_64x48].sad  = PFX(pixel_sad_64x48_neon);
-        p.pu[LUMA_12x16].sad  = PFX(pixel_sad_12x16_neon);
-        p.pu[LUMA_24x32].sad  = PFX(pixel_sad_24x32_neon);
-        p.pu[LUMA_48x64].sad  = PFX(pixel_sad_48x64_neon);
-
-        // vertical interpolation filters
-        p.pu[LUMA_4x4].luma_vpp     = PFX(interp_8tap_vert_pp_4x4_neon);
-        p.pu[LUMA_4x8].luma_vpp     = PFX(interp_8tap_vert_pp_4x8_neon);
-        p.pu[LUMA_4x16].luma_vpp    = PFX(interp_8tap_vert_pp_4x16_neon);
-        p.pu[LUMA_8x4].luma_vpp     = PFX(interp_8tap_vert_pp_8x4_neon);
-        p.pu[LUMA_8x8].luma_vpp     = PFX(interp_8tap_vert_pp_8x8_neon);
-        p.pu[LUMA_8x16].luma_vpp    = PFX(interp_8tap_vert_pp_8x16_neon);
-        p.pu[LUMA_8x32].luma_vpp    = PFX(interp_8tap_vert_pp_8x32_neon);
-        p.pu[LUMA_16x4].luma_vpp    = PFX(interp_8tap_vert_pp_16x4_neon);
-        p.pu[LUMA_16x8].luma_vpp    = PFX(interp_8tap_vert_pp_16x8_neon);
-        p.pu[LUMA_16x16].luma_vpp   = PFX(interp_8tap_vert_pp_16x16_neon);
-        p.pu[LUMA_16x32].luma_vpp   = PFX(interp_8tap_vert_pp_16x32_neon);
-        p.pu[LUMA_16x64].luma_vpp   = PFX(interp_8tap_vert_pp_16x64_neon);
-        p.pu[LUMA_16x12].luma_vpp   = PFX(interp_8tap_vert_pp_16x12_neon);
-        p.pu[LUMA_32x8].luma_vpp    = PFX(interp_8tap_vert_pp_32x8_neon);
-        p.pu[LUMA_32x16].luma_vpp   = PFX(interp_8tap_vert_pp_32x16_neon);
-        p.pu[LUMA_32x32].luma_vpp   = PFX(interp_8tap_vert_pp_32x32_neon);
-        p.pu[LUMA_32x64].luma_vpp   = PFX(interp_8tap_vert_pp_32x64_neon);
-        p.pu[LUMA_32x24].luma_vpp   = PFX(interp_8tap_vert_pp_32x24_neon);
-        p.pu[LUMA_64x16].luma_vpp   = PFX(interp_8tap_vert_pp_64x16_neon);
-        p.pu[LUMA_64x32].luma_vpp   = PFX(interp_8tap_vert_pp_64x32_neon);
-        p.pu[LUMA_64x64].luma_vpp   = PFX(interp_8tap_vert_pp_64x64_neon);
-        p.pu[LUMA_64x48].luma_vpp   = PFX(interp_8tap_vert_pp_64x48_neon);
-        p.pu[LUMA_24x32].luma_vpp   = PFX(interp_8tap_vert_pp_24x32_neon);
-        p.pu[LUMA_48x64].luma_vpp   = PFX(interp_8tap_vert_pp_48x64_neon);
-        p.pu[LUMA_12x16].luma_vpp   = PFX(interp_8tap_vert_pp_12x16_neon);
-
-        p.pu[LUMA_4x4].luma_vsp     = PFX(interp_8tap_vert_sp_4x4_neon);
-        p.pu[LUMA_4x8].luma_vsp     = PFX(interp_8tap_vert_sp_4x8_neon);
-        p.pu[LUMA_4x16].luma_vsp    = PFX(interp_8tap_vert_sp_4x16_neon);
-        p.pu[LUMA_8x4].luma_vsp     = PFX(interp_8tap_vert_sp_8x4_neon);
-        p.pu[LUMA_8x8].luma_vsp     = PFX(interp_8tap_vert_sp_8x8_neon);
-        p.pu[LUMA_8x16].luma_vsp    = PFX(interp_8tap_vert_sp_8x16_neon);
-        p.pu[LUMA_8x32].luma_vsp    = PFX(interp_8tap_vert_sp_8x32_neon);
-        p.pu[LUMA_16x4].luma_vsp    = PFX(interp_8tap_vert_sp_16x4_neon);
-        p.pu[LUMA_16x8].luma_vsp    = PFX(interp_8tap_vert_sp_16x8_neon);
-        p.pu[LUMA_16x16].luma_vsp   = PFX(interp_8tap_vert_sp_16x16_neon);
-        p.pu[LUMA_16x32].luma_vsp   = PFX(interp_8tap_vert_sp_16x32_neon);
-        p.pu[LUMA_16x64].luma_vsp   = PFX(interp_8tap_vert_sp_16x64_neon);
-        p.pu[LUMA_16x12].luma_vsp   = PFX(interp_8tap_vert_sp_16x12_neon);
-        p.pu[LUMA_32x8].luma_vsp    = PFX(interp_8tap_vert_sp_32x8_neon);
-        p.pu[LUMA_32x16].luma_vsp   = PFX(interp_8tap_vert_sp_32x16_neon);
-        p.pu[LUMA_32x32].luma_vsp   = PFX(interp_8tap_vert_sp_32x32_neon);
-        p.pu[LUMA_32x64].luma_vsp   = PFX(interp_8tap_vert_sp_32x64_neon);
-        p.pu[LUMA_32x24].luma_vsp   = PFX(interp_8tap_vert_sp_32x24_neon);
-        p.pu[LUMA_64x16].luma_vsp   = PFX(interp_8tap_vert_sp_64x16_neon);
-        p.pu[LUMA_64x32].luma_vsp   = PFX(interp_8tap_vert_sp_64x32_neon);
-        p.pu[LUMA_64x64].luma_vsp   = PFX(interp_8tap_vert_sp_64x64_neon);
-        p.pu[LUMA_64x48].luma_vsp   = PFX(interp_8tap_vert_sp_64x48_neon);
-        p.pu[LUMA_24x32].luma_vsp   = PFX(interp_8tap_vert_sp_24x32_neon);
-        p.pu[LUMA_48x64].luma_vsp   = PFX(interp_8tap_vert_sp_48x64_neon);
-        p.pu[LUMA_12x16].luma_vsp   = PFX(interp_8tap_vert_sp_12x16_neon);
-
-        p.pu[LUMA_4x4].luma_vps     = PFX(interp_8tap_vert_ps_4x4_neon);
-        p.pu[LUMA_4x8].luma_vps     = PFX(interp_8tap_vert_ps_4x8_neon);
-        p.pu[LUMA_4x16].luma_vps    = PFX(interp_8tap_vert_ps_4x16_neon);
-        p.pu[LUMA_8x4].luma_vps     = PFX(interp_8tap_vert_ps_8x4_neon);
-        p.pu[LUMA_8x8].luma_vps     = PFX(interp_8tap_vert_ps_8x8_neon);
-        p.pu[LUMA_8x16].luma_vps    = PFX(interp_8tap_vert_ps_8x16_neon);
-        p.pu[LUMA_8x32].luma_vps    = PFX(interp_8tap_vert_ps_8x32_neon);
-        p.pu[LUMA_16x4].luma_vps    = PFX(interp_8tap_vert_ps_16x4_neon);
-        p.pu[LUMA_16x8].luma_vps    = PFX(interp_8tap_vert_ps_16x8_neon);
-        p.pu[LUMA_16x16].luma_vps   = PFX(interp_8tap_vert_ps_16x16_neon);
-        p.pu[LUMA_16x32].luma_vps   = PFX(interp_8tap_vert_ps_16x32_neon);
-        p.pu[LUMA_16x64].luma_vps   = PFX(interp_8tap_vert_ps_16x64_neon);
-        p.pu[LUMA_16x12].luma_vps   = PFX(interp_8tap_vert_ps_16x12_neon);
-        p.pu[LUMA_32x8].luma_vps    = PFX(interp_8tap_vert_ps_32x8_neon);
-        p.pu[LUMA_32x16].luma_vps   = PFX(interp_8tap_vert_ps_32x16_neon);
-        p.pu[LUMA_32x32].luma_vps   = PFX(interp_8tap_vert_ps_32x32_neon);
-        p.pu[LUMA_32x64].luma_vps   = PFX(interp_8tap_vert_ps_32x64_neon);
-        p.pu[LUMA_32x24].luma_vps   = PFX(interp_8tap_vert_ps_32x24_neon);
-        p.pu[LUMA_64x16].luma_vps   = PFX(interp_8tap_vert_ps_64x16_neon);
-        p.pu[LUMA_64x32].luma_vps   = PFX(interp_8tap_vert_ps_64x32_neon);
-        p.pu[LUMA_64x64].luma_vps   = PFX(interp_8tap_vert_ps_64x64_neon);
-        p.pu[LUMA_64x48].luma_vps   = PFX(interp_8tap_vert_ps_64x48_neon);
-        p.pu[LUMA_24x32].luma_vps   = PFX(interp_8tap_vert_ps_24x32_neon);
-        p.pu[LUMA_48x64].luma_vps   = PFX(interp_8tap_vert_ps_48x64_neon);
-        p.pu[LUMA_12x16].luma_vps   = PFX(interp_8tap_vert_ps_12x16_neon);
-
         //vertical chroma filters
         p.chroma[X265_CSP_I420].pu[CHROMA_420_8x2].filter_vpp = PFX(interp_4tap_vert_pp_8x2_neon);
         p.chroma[X265_CSP_I420].pu[CHROMA_420_8x4].filter_vpp = PFX(interp_4tap_vert_pp_8x4_neon);
@@ -1263,60 +960,6 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.chroma[X265_CSP_I444].pu[LUMA_64x32].filter_hps = PFX(interp_4tap_horiz_ps_64x32_neon);
         p.chroma[X265_CSP_I444].pu[LUMA_64x48].filter_hps = PFX(interp_4tap_horiz_ps_64x48_neon);
         p.chroma[X265_CSP_I444].pu[LUMA_64x64].filter_hps = PFX(interp_4tap_horiz_ps_64x64_neon);
-
-        // luma_hpp
-        p.pu[LUMA_4x4].luma_hpp   = PFX(interp_horiz_pp_4x4_neon);
-        p.pu[LUMA_4x8].luma_hpp   = PFX(interp_horiz_pp_4x8_neon);
-        p.pu[LUMA_4x16].luma_hpp  = PFX(interp_horiz_pp_4x16_neon);
-        p.pu[LUMA_8x4].luma_hpp   = PFX(interp_horiz_pp_8x4_neon);
-        p.pu[LUMA_8x8].luma_hpp   = PFX(interp_horiz_pp_8x8_neon);
-        p.pu[LUMA_8x16].luma_hpp  = PFX(interp_horiz_pp_8x16_neon);
-        p.pu[LUMA_8x32].luma_hpp  = PFX(interp_horiz_pp_8x32_neon);
-        p.pu[LUMA_12x16].luma_hpp = PFX(interp_horiz_pp_12x16_neon);
-        p.pu[LUMA_16x4].luma_hpp  = PFX(interp_horiz_pp_16x4_neon);
-        p.pu[LUMA_16x8].luma_hpp  = PFX(interp_horiz_pp_16x8_neon);
-        p.pu[LUMA_16x12].luma_hpp = PFX(interp_horiz_pp_16x12_neon);
-        p.pu[LUMA_16x16].luma_hpp = PFX(interp_horiz_pp_16x16_neon);
-        p.pu[LUMA_16x32].luma_hpp = PFX(interp_horiz_pp_16x32_neon);
-        p.pu[LUMA_16x64].luma_hpp = PFX(interp_horiz_pp_16x64_neon);
-        p.pu[LUMA_24x32].luma_hpp = PFX(interp_horiz_pp_24x32_neon);
-        p.pu[LUMA_32x8].luma_hpp  = PFX(interp_horiz_pp_32x8_neon);
-        p.pu[LUMA_32x16].luma_hpp = PFX(interp_horiz_pp_32x16_neon);
-        p.pu[LUMA_32x24].luma_hpp = PFX(interp_horiz_pp_32x24_neon);
-        p.pu[LUMA_32x32].luma_hpp = PFX(interp_horiz_pp_32x32_neon);
-        p.pu[LUMA_32x64].luma_hpp = PFX(interp_horiz_pp_32x64_neon);
-        p.pu[LUMA_48x64].luma_hpp = PFX(interp_horiz_pp_48x64_neon);
-        p.pu[LUMA_64x16].luma_hpp = PFX(interp_horiz_pp_64x16_neon);
-        p.pu[LUMA_64x32].luma_hpp = PFX(interp_horiz_pp_64x32_neon);
-        p.pu[LUMA_64x48].luma_hpp = PFX(interp_horiz_pp_64x48_neon);
-        p.pu[LUMA_64x64].luma_hpp = PFX(interp_horiz_pp_64x64_neon);
-
-        // luma_hps
-        p.pu[LUMA_4x4].luma_hps   = PFX(interp_horiz_ps_4x4_neon);
-        p.pu[LUMA_4x8].luma_hps   = PFX(interp_horiz_ps_4x8_neon);
-        p.pu[LUMA_4x16].luma_hps  = PFX(interp_horiz_ps_4x16_neon);
-        p.pu[LUMA_8x4].luma_hps   = PFX(interp_horiz_ps_8x4_neon);
-        p.pu[LUMA_8x8].luma_hps   = PFX(interp_horiz_ps_8x8_neon);
-        p.pu[LUMA_8x16].luma_hps  = PFX(interp_horiz_ps_8x16_neon);
-        p.pu[LUMA_8x32].luma_hps  = PFX(interp_horiz_ps_8x32_neon);
-        p.pu[LUMA_12x16].luma_hps = PFX(interp_horiz_ps_12x16_neon);
-        p.pu[LUMA_16x4].luma_hps  = PFX(interp_horiz_ps_16x4_neon);
-        p.pu[LUMA_16x8].luma_hps  = PFX(interp_horiz_ps_16x8_neon);
-        p.pu[LUMA_16x12].luma_hps = PFX(interp_horiz_ps_16x12_neon);
-        p.pu[LUMA_16x16].luma_hps = PFX(interp_horiz_ps_16x16_neon);
-        p.pu[LUMA_16x32].luma_hps = PFX(interp_horiz_ps_16x32_neon);
-        p.pu[LUMA_16x64].luma_hps = PFX(interp_horiz_ps_16x64_neon);
-        p.pu[LUMA_24x32].luma_hps = PFX(interp_horiz_ps_24x32_neon);
-        p.pu[LUMA_32x8].luma_hps  = PFX(interp_horiz_ps_32x8_neon);
-        p.pu[LUMA_32x16].luma_hps = PFX(interp_horiz_ps_32x16_neon);
-        p.pu[LUMA_32x24].luma_hps = PFX(interp_horiz_ps_32x24_neon);
-        p.pu[LUMA_32x32].luma_hps = PFX(interp_horiz_ps_32x32_neon);
-        p.pu[LUMA_32x64].luma_hps = PFX(interp_horiz_ps_32x64_neon);
-        p.pu[LUMA_48x64].luma_hps = PFX(interp_horiz_ps_48x64_neon);
-        p.pu[LUMA_64x16].luma_hps = PFX(interp_horiz_ps_64x16_neon);
-        p.pu[LUMA_64x32].luma_hps = PFX(interp_horiz_ps_64x32_neon);
-        p.pu[LUMA_64x48].luma_hps = PFX(interp_horiz_ps_64x48_neon);
-        p.pu[LUMA_64x64].luma_hps = PFX(interp_horiz_ps_64x64_neon);
     }
 }
 } // namespace X265_NS
-- 
2.25.1

